% CameraFit(x,y,bn)
%
% Fit a function that models the *forward* color rendering pipeline
% of a camera, using a simpler linear transfor+per-channel
% polynomial model, followed by gamut correction.
%
%    x:   3xN training RAW values.
%    y:   3xN training JPEG values.
%    bn:  Basename to store training data as.
%
% -- Ayan Chakrabarti <ayanc@eecs.harvard.edu>
function CameraFit(x,y,bn,nfact,dbg)

if ~exist('nfact')
  nfact = 1;
end;


% Fit part 1
if ~exist('dbg')
    SimpleFit(x,y,bn,nfact); 
end;

ySimple = SimpleRender(x,bn);
SimpleErr = y - max(0,min(255,ySimple));

xNew = ySimple/255;

GamutFit(xNew,SimpleErr,bn);
CameraStats(x,y,bn);