% CameraStats(x,y,bn)
%
% Stores essential statistics that will be useful in computing the
% probabilistic inverse--- the training error and the convex hull
% of the training set.
%
%    x:   3xN training RAW values.
%    y:   3xN training JPEG values.
%    bn:  Basename to store training data as.
%
% -- Ayan Chakrabarti <ayanc@eecs.harvard.edu>
function CameraStats(x,y,bn)

h = getHull(x,0);
yp = Render(x,bn);
rmse = sqrt(mean((yp(:)-y(:)).^2));

save('-mat',[bn '_stats.mat'],'h','rmse');
