% dy = GamutEst(x,bn)
%
% Estimate deviation due to gamut mapping, using function estimated
% with GamutFit(..,..,bn).
%
% -- Ayan Chakrabarti <ayanc@eecs.harvard.edu>
function dy = GamutEst(x,bn)

global SVM_PREDICT;

tm = [tempname '.svm1']; 
tm2 = [tempname '.svm2'];

dy = zeros(size(x));

cmd = '';

fid = fopen(tm,'wt');
xyi = [zeros(1,size(x,2)); x];
fprintf(fid,'%f 1: %f 2: %f 3: %f\n',xyi);
fclose(fid);

cmd = '';
for i = 1:3
  trn = sprintf('%s.c%d',bn,i);
  cmd = [cmd SVM_PREDICT ' ' tm ' ' trn ' ' tm2 num2str(i) ' & '];
end;
system([cmd 'wait']);
delete(tm);
for i  = 1:3
  fid = fopen([tm2 num2str(i)],'rt');
  z = fscanf(fid,'%f',[1 size(x,2)]);
  dy(i,:) = z;
  fclose(fid);
  delete([tm2 num2str(i)]);
end;

