% y = SimpleInverse(x,bn)
%
% Find inverse of simple render (useful for vignetting fitting).
%
% -- Ayan Chakrabarti <ayanc@eecs.harvard.edu>
function x = SimpleInverse(y,bn)

d = load('-mat',[bn '_T.mat']);

lutx = linspace(-min(d.T(:)),max(sum(max(0,d.T),2)),10000);
luty = d.coeffs(1,:)*polyaug(lutx,d.deg);


yc = y(:);
for i = 1:length(yc)
    fprintf('\r Inverting %d of %d             ',i,length(yc));
    sc = (luty - yc(i)).^2;
    idx = find(sc == min(sc));
    idx = idx(round( (length(idx)+1)/2));
    yc(i) = lutx(idx);
end;

fprintf('\n');
yc = reshape(yc,size(y));


x = inv(d.T)*yc;
x = max(0,min(1,x));