% Utility function that takes an 1xN vector, and generates a
% (deg+1)xN matrix where each column corresponds to the powers of
% the original value.
%
% -- Ayan Chakrabarti <ayanc@eecs.harvard.edu>
function y = polyaug(x,deg)

y = zeros(deg+1,size(x,2));
y(1,:) = 1;
for i = 1:deg
  y(i+1,:) = x.^i;
end;