% [x,y] = selSubset(c,es,is)
%
% Select a subset of the full camera data.
%
%   c: Camera data structure from loading camera data file as
%        c = load(matfilename);
%   es: Exposure index or equally sampled sub-set (if negative) or
%       all (if 0)
%   is: Subset of illuminants
function [x,y] = selSubset(c,es,ls)

x = []; y = [];

for i = 1:length(ls)
    l = ls(i);
    if  es < 0
        eset = round(linspace(1,c.nEI(l),-es));
    else 
      if es == 0
	eset = [1:c.nEI(l)];
      else
        eset = es;
      end;
    end;

    for j = 1:length(eset)
        ex = eset(j);
        x = [x c.R(:,:,find(c.eTag == ex & c.iTag == l))];
        y = [y c.J(:,:,find(c.eTag == ex & c.iTag == l))];
    end;
end;
y = round(y);