% InvertBaseQ(basename)
%
% Call after calling InvertBase, to be able to use invJ.
%
% -- Ayan Chakrabarti <ayanc@eecs.harvard.edu>
function subIdx = InvertBaseQ(bn)

Q = 8; sQ = 16;

d = load([bn '_INV.mat']);
y = d.y; x = d.x;
Js = min(d.Js,5);

grid = [0:Q:255]+(Q-1)/2;

subIdx = cell(length(grid)/sQ,length(grid),length(grid));

lgwts = log(d.wts);

y2 = sum(y.^2,1); 
Js22 = 2*Js^2;
lgwts = Js22*lgwts - y2;
thresh = -12*Js22 - Js22*3*((Q-1)/2)^2;

count = 1;
for r1 = 0:(sQ-1)
for r2 = 1:length(grid)/sQ
  r = r1*length(grid)/sQ+r2;
  for g = 1:length(grid)
    for b = 1:length(grid)

      J = [grid(r);grid(g);grid(b)];
      fprintf('\r Estimating %d of %d                ',count,length(grid)^3);
      count = count+1;
      
      % Uncomment the next 3 lines if you can't compile corrMax
      %wexpi = -2*(y(1,:)*J(1)+y(2,:)*J(2)+y(3,:)*J(3));
      %wexpi = lgwts-wexpi;
      %wexpi = wexpi - max(wexpi);
      wexpi = corrMax(J(1),J(2),J(3));
      
      idx = find(wexpi > thresh); 
      
      subIdx{r2,g,b} = uint32(idx);
      
    end;
  end;
end;
save('-mat','-v7.3',[bn '_INVQ_' num2str(r1) '.mat'],'subIdx');
end;
fprintf('\n');
