% [mu,cv] = invJ(J,bn)
%
% Compute the mean and covariance matrices of Raw given JPEG. Call
% with J as a 3x... matrix, returns mu as 3x... and cv as
% 3x3x.... Here bn is the basename with which the forward fits and
% InvertBase function were called.
%
% -- Ayan Chakrabarti <ayanc@eecs.harvard.edu>
function [mu cv] = invJ(J,bn)

sz = size(J);
J = reshape(J,[3 prod(sz)/3]);

g = J(1,:)*256^2+J(2,:)*256+J(3,:);
[u,ia,ic] = unique(g);
fprintf('Speedup factor: %f\n',length(g)/length(u));

Ju = J(:,ia);
[mu,cv] = invJQ(Ju,bn);
mu = mu(:,ic);
cv = cv(:,:,ic);

mu = reshape(mu,sz);
cv = reshape(cv,[3 sz]);
